/* Copyright (C) 1995 Aladdin Enterprises.  All rights reserved.
  
  This file is part of Aladdin Ghostscript.
  
  Aladdin Ghostscript is distributed with NO WARRANTY OF ANY KIND.  No author
  or distributor accepts any responsibility for the consequences of using it,
  or for whether it serves any particular purpose or works at all, unless he
  or she says so in writing.  Refer to the Aladdin Ghostscript Free Public
  License (the "License") for full details.
  
  Every copy of Aladdin Ghostscript must include a copy of the License,
  normally in a plain ASCII text file named PUBLIC.  The License grants you
  the right to copy, modify and redistribute Aladdin Ghostscript, but only
  under certain conditions described in the License.  Among other things, the
  License requires that the copyright notice and this notice be preserved on
  all copies.
*/

/* icfontab.c */
/* Table of compiled fonts */
#include "ccfont.h"

/* This is compiled separately and linked with the fonts themselves, */
/* in a shared library when applicable. */

#undef font_
#define font_(fname, fproc, zfproc) extern ccfont_fproc fproc;
#ifndef GCONFIGF_H
# include "gconfigf.h"
#else
# include GCONFIGF_H
#endif

private ccfont_fproc *fprocs[] = {
#undef font_
#define font_(fname, fproc, zfproc) &fproc, /* fname, zfproc are not needed */
#ifndef GCONFIGF_H
# include "gconfigf.h"
#else
# include GCONFIGF_H
#endif
  0
};

int
ccfont_fprocs(int *pnum_fprocs, ccfont_fproc ***pfprocs)
{
  *pnum_fprocs = countof(fprocs) - 1;
  *pfprocs = &fprocs[0];
  return ccfont_version;	/* for compatibility checking */
}
